/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3904_CDPFUNO_VALIDA_DATA_PRODUCAO.SQL

@C:\Web_505\Sql\End_Conv\Oracle\3904_CDPFUNO_VALIDA_DATA_PRODUCAO.SQL

Descrio:
   Funo para enquadramento da data de produo nos dias e horarios disponiveis do equipamentos

Criao:
30/10/2008 - Welbert G. Moitinha
*/


create or replace
FUNCTION VALIDA_DATA_PRODUCAO(P_CDFILIAL IN FILIAL.CDFILIAL%TYPE,
                                                 P_DTMRP           IN DATE,
                                                 P_CDPRODUTO       IN PRODUTO.CDPRODUTO%TYPE,
                                                 P_DATA_VALIDAR    IN DATE,
                                                 P_NRTOTLOTEDIA    IN INTEGER,
                                                 P_CDPERIPRODU     IN CALEPRODUCAO.CDPERIPRODU%TYPE,
                                                 P_QTHRSETUPRECUR  IN FLOAT,
                                                 
                                                 ----------Variveis de entrada e Sada---------------
                                                 P_QTDEMINUTOSUTIL IN      FLOAT,
                                                 P_CDEQUIPPRO      IN OUT  EQUIPAPROD.CDEQUIPPRO%TYPE,
                                                 -----------------------------------------------------
                                                 
                                                 P_DTFINALPROD     OUT DATE,
                                                 
                                                ------Variveis da etapa (para equip. alternativs)----
                                                P_CDPROCFABRIC  PROCFABRICA.CDPROCFABRIC%TYPE,
                                                P_CDETAPAPROD   ETAPAPROD.CDETAPAPROD   %TYPE,
                                                P_CDINSPECAO    INSPECAO.CDINSPECAO     %TYPE,
                                                P_NRINSPETAPA   INSPETAPA.NRINSPETAPA   %TYPE,
                                                P_NRRECURETAPA  RECURETAPA.NRRECURETAPA %TYPE,
                                                P_QTPRODUZIR    FLOAT,
                                                 
                                                 --------------Variveis de Sada---------------
                                                 P_NRTURNO         OUT VARCHAR,
                                                 P_MSGERROR        OUT VARCHAR) RETURN DATE
IS
   V_DTAPRODUZIR   DATE;
   V_VEXISHORATUR  TURNO_PRODUCAO.HRINITURNO%TYPE;
   V_TURNOFIMANT   TURNO_PRODUCAO.HRFIMTURNO%TYPE;
   V_LOTEDISPON    VARCHAR2(1);
   V_DTPRODUCAO    DATE;
   V_NRLOTESDIAS   INTEGER;
   V_NRTURNO TURNO.NRTURNO%TYPE;
   V_DTAUXI        DATE;
   V_QTHRTURNO     FLOAT;
   V_DTRESEREQUIP  DATE;
   V_QTDEMINEQUIP  FLOAT;
   V_DTFINALPROD   DATE;
   V_DTHRINICTURNO DATE;
   V_DTHRFIMTURNO  DATE;
   
   V_DTPRODTMP     DATE;
   V_DTPRODTMP2    DATE;
   
   ---Equipamentos j utilizados no planejamento---
   V_CDEQUIPCALE    EQUIPAPROD.CDEQUIPPRO%TYPE;
   V_DTINIEQUIPCALE DATE;
   V_DTFINEQUIPCALE DATE;
   V_EQUIPLIBERADO  VARCHAR2(1);
   ------------------------------------------------
   
   V_NRTURNOALT TURNO_PRODUCAO.NRTURNO%TYPE; 
   V_HRINITURNO TURNO_PRODUCAO.HRINITURNO%TYPE;
   V_HRFIMTURNO TURNO_PRODUCAO.HRFIMTURNO%TYPE;
   V_QTHRRESTURNO FLOAT;
   
   ----Informar Equipamentos J validados, para no dar Loop no equip alternativo---
   V_EQUIPVALID VARCHAR2(1000);
BEGIN
   V_DTAPRODUZIR := P_DATA_VALIDAR;
   P_DTFINALPROD := NULL;
   V_DTFINALPROD := NULL;
   V_NRTURNO     :=   '';   
   IF P_QTDEMINUTOSUTIL < (1/24) THEN
      V_QTDEMINEQUIP := (1/24);
   ELSE
      V_QTDEMINEQUIP := P_QTDEMINUTOSUTIL;
   END IF;

   IF P_DATA_VALIDAR < SYSDATE THEN
      RETURN(NULL);
   END IF;
   
   

   V_DTAPRODUZIR := ENCAIXA_PRODUCAO_TURNO(P_CDFILIAL,V_DTAPRODUZIR,P_CDPERIPRODU,V_QTDEMINEQUIP,P_MSGERROR,'S');

   --Verifica se todos os lotes possveis do dia j foram gerados 
   V_LOTEDISPON := 'N';

   WHILE V_LOTEDISPON = 'N'
   LOOP
      SELECT
         COUNT(*)
      INTO
         V_NRLOTESDIAS
      FROM
         CALEPRODMRP
      WHERE
         (CDFILIAL              = P_CDFILIAL)          AND
         (DTPROGPRODCP          = P_DTMRP)             AND
         (CDPRODUTO             = P_CDPRODUTO) AND
         (TO_DATE(DTCONCPROMRP) = TO_DATE(V_DTAPRODUZIR));

      --VERIFICA SE J ATINGIU A QUANTIDADE MXIMA DE LOTES PRODUZIDOS POR DIA
      IF (V_NRLOTESDIAS = P_NRTOTLOTEDIA) THEN
          --Se j tiver atingido a quantidade mxima de lotes por dia, transfere a produo para o dia anterior (E revalida o mesmo)
          V_DTAPRODUZIR := ENCAIXA_PRODUCAO_TURNO(P_CDFILIAL,(TRUNC(V_DTAPRODUZIR)-(1/24/60)-V_QTDEMINEQUIP),P_CDPERIPRODU,V_QTDEMINEQUIP,P_MSGERROR,'S');
      ELSE
         V_LOTEDISPON := 'S';
      END IF;            
   END LOOP;   
   
   --VERIFICA SE EXISTE SOLICITAO ABERTA PARA O EQUIPAMENTO NOS DIAS DA PRODUO
   V_EQUIPLIBERADO := 'N';
   --Lista de Equipamentos j validados, para evitar loop infinito na busca por equipamento alternativo
   V_EQUIPVALID  :=   ' '; 
   WHILE V_EQUIPLIBERADO = 'N'
   LOOP
      BEGIN
        SELECT P.DTINPATIVTAR
        INTO V_DTRESEREQUIP
        FROM SOLISERV S,
             TAREFA T,
             PLANATIVTARE P
        WHERE
           S.CDFILIAL = P_CDFILIAL AND
          S.CDEQUIPPRO = P_CDEQUIPPRO AND
          (T.IDORIGTARE    = '1') AND
          ((IDSTATUSSOLI   = 'P') OR(IDSTATUSSOLI   = 'A')) AND
          (P.DTINPATIVTAR BETWEEN V_DTAPRODUZIR AND (V_DTAPRODUZIR + V_QTDEMINEQUIP)) AND
          P.DTCONATIVTAR IS NULL AND
          S.CDFILIAL = T.CDFILIAL AND
          S.NRSOLISERV = T.NRSOLISERV AND
          P.CDFILIAL = T.CDFILIAL AND
          P.NRTAREFA =T.NRTAREFA;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           V_DTRESEREQUIP := NULL;
      END;
      
      IF NOT V_DTRESEREQUIP IS NULL THEN
         
          --------------------------------------------------------------------------------------------------------- 
          -- Se houver solicitao de manuteno para o equipamento no dia de produo,
          -- revalida a partir da hora de incio da solicitao menos 1 min e menos o tempo necessrio para produzir, 
          -- assim termina a produo 1 minuto antes do momento olicitado, e guarda o resultado em uma varivel 
          -- temporria.
          ---------------------------------------------------------------------------------------------------------
          V_DTPRODTMP  :=  ENCAIXA_PRODUCAO_TURNO(P_CDFILIAL,V_DTRESEREQUIP - (1/24/60) - V_QTDEMINEQUIP,P_CDPERIPRODU,V_QTDEMINEQUIP,P_MSGERROR,'S');
      ELSE
        BEGIN
           SELECT MAX(DTHRINIPROD)
           INTO V_DTRESEREQUIP
           FROM RESERVEQUIPAPRO
           WHERE
             (CDFILIAL   = P_CDFILIAL) AND
             (CDEQUIPPRO = P_CDEQUIPPRO) AND
             (V_DTAPRODUZIR BETWEEN DTHRINIPROD AND DTHRFINPROD)AND
             ((V_DTAPRODUZIR + V_QTDEMINEQUIP)BETWEEN DTHRINIPROD AND DTHRFINPROD);
        EXCEPTION
          WHEN NO_DATA_FOUND THEN
              V_DTRESEREQUIP := NULL;
        END;
      END IF;

      --VERIFICA SE H RESERVA PARA O EQUIPAMENTO (SE ELE EST SENDO UTILIZADO POR OUTRO PRODUTO)
      IF NOT V_DTRESEREQUIP IS NULL THEN
         ---------------------------------------------------------------------------------------------------------- 
         --  Se o equipamento estiver reservado (j estiver sendo utilizado em um OP, por exemplo),
         --  revalida a partir da hora de incio da reserva menos 1 min e menos o tempo necessrio para produzir, 
         --  assim termina a produo 1 minuto antes do momento reservado, e guarda o resultado em uma varivel 
         --  temporria.
         ---------------------------------------------------------------------------------------------------------
          V_DTPRODTMP  :=  ENCAIXA_PRODUCAO_TURNO(P_CDFILIAL,V_DTRESEREQUIP - (1/24/60) - V_QTDEMINEQUIP,P_CDPERIPRODU,V_QTDEMINEQUIP,P_MSGERROR,'S');
          
      ELSE
     
        --VERIFICA SE O EQUIPAMENTO J FOI ALOCADO PARA OUTRA ETAPA (SE EST DISPONVEL)
        BEGIN
          SELECT  CDEQUIPPRO,DTHRINIUTEQUIP,DTHRFINUTEQUIP
          INTO
             V_CDEQUIPCALE, V_DTINIEQUIPCALE, V_DTFINEQUIPCALE        
          FROM
            (SELECT
                C.CDEQUIPPRO,C.DTHRINIUTEQUIP,C.DTHRFINUTEQUIP        
             FROM 
                CALENDEQUIPAPRO C
             WHERE
                C.CDFILIAL      = P_CDFILIAL   AND
                C.CDEQUIPPRO    = P_CDEQUIPPRO AND
                C.DTPROGUTEQUIP = P_DTMRP      AND                
            (
              (C.DTHRFINUTEQUIP BETWEEN V_DTAPRODUZIR AND (V_DTAPRODUZIR+V_QTDEMINEQUIP)) OR
              (C.DTHRINIUTEQUIP BETWEEN V_DTAPRODUZIR AND (V_DTAPRODUZIR+V_QTDEMINEQUIP)) OR
              (V_DTAPRODUZIR BETWEEN C.DTHRINIUTEQUIP AND C.DTHRFINUTEQUIP) OR
              ((V_DTAPRODUZIR+V_QTDEMINEQUIP) BETWEEN C.DTHRINIUTEQUIP AND C.DTHRFINUTEQUIP) 
            )
            ORDER BY C.DTHRINIUTEQUIP        
            ) 
          WHERE ROWNUM = 1;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN
             V_CDEQUIPCALE := NULL;
        END;
        IF NOT V_CDEQUIPCALE IS NULL THEN   
             --------------------------------------------------------------------------------------------------------- 
             -- Se o equipamento j tiver sido alocado, no perodo encontrado, para outro produto no
             -- mesmo MRP, revalida a partir da hora de incio de utilizao do turno concorrente menos 1 min
             -- menos o tempo necessrio para produzir, assim termina a produo 1 minuto antes do momento reservado,
             -- e guarda o resultado em uma varivel temporria.
             -- Obs.: O Select acima sempre trar o menor horrio de utilizao do equipamento, de forma que o
             -- mesmo no estar sendo utilizado antes desse horrio (por esse motivo que se subtrai 1 min.)
             ---------------------------------------------------------------------------------------------------------
            V_DTPRODTMP  :=  ENCAIXA_PRODUCAO_TURNO(P_CDFILIAL,V_DTINIEQUIPCALE - (1/24/60) - V_QTDEMINEQUIP,P_CDPERIPRODU,V_QTDEMINEQUIP,P_MSGERROR,'S');
            
        ELSE
           V_EQUIPLIBERADO := 'S';
        END IF;   
        
        IF V_EQUIPLIBERADO <> 'S' THEN
            --------------------------------------------------------------------------------------------------------- 
            --  Traz todos os equipamentos alternativos para a produo do produto, conforme o Processo de Fabricao. 
            --  Se no houver dados, a data a produzir ser a V_DTPRODTMP conforme calculado acima.
            --  Se houver, o sistema tentar encontrar um equipamento alternativo que se utilizado, faa com que
            --  a produo demore menos do que utilizando V_DTPRODTMP (Possivelmente no mesmo turno, utilizando 
            --  os equipamentos em paralelo)
            ------------------------------------------------------------------------------------------------------- 
            FOR C_EQUIPAMENTOS IN(SELECT E.NRORDUTILEQUIP, E.CDEQUIPPRO, E.VRCAPEQUIPPROD, E.QTHRUTIEQUIPROD,
                                            E.IDLIBERAEQUIPA,E.IDEQUIPPADRAO,((P_QTPRODUZIR * E.QTHRUTIEQUIPROD)/E.VRCAPEQUIPPROD/24)+P_QTHRSETUPRECUR/24 AS QTHRSUTILEQUIP
                                        FROM  EQUIPRECUETAPA E
                                        WHERE
                                            CDFILIAL     = P_CDFILIAL     AND
                                            CDPRODUTO    = P_CDPRODUTO    AND
                                            CDPROCFABRIC = P_CDPROCFABRIC AND
                                            CDETAPAPROD  = P_CDETAPAPROD  AND
                                            CDINSPECAO   = P_CDINSPECAO   AND
                                            NRINSPETAPA  = P_NRINSPETAPA  AND
                                            NRRECURETAPA = P_NRRECURETAPA AND
                                            CDEQUIPPRO  <> P_CDEQUIPPRO   AND 
                                            (INSTR(V_EQUIPVALID,P_CDEQUIPPRO) = 0) AND 
                                            NOT EXISTS
                                                                                       
                                           -----------Escolhe equipamento que no seja alocado para este horrio---------
                                           (SELECT
                                                  C.CDEQUIPPRO,C.DTHRINIUTEQUIP,C.DTHRFINUTEQUIP,C.DTPROGUTEQUIP
                                           FROM 
                                                  CALENDEQUIPAPRO C
                                           WHERE
                                           C.CDFILIAL      = P_CDFILIAL         AND
                                           C.CDEQUIPPRO    = E.CDEQUIPPRO       AND
                                           TRUNC( C.DTPROGUTEQUIP) = P_DTMRP    AND
                                              (
                                                  (C.DTHRFINUTEQUIP BETWEEN V_DTAPRODUZIR AND (V_DTAPRODUZIR+((P_QTPRODUZIR * E.QTHRUTIEQUIPROD)/E.VRCAPEQUIPPROD/24)))    OR
                                                  (C.DTHRINIUTEQUIP BETWEEN V_DTAPRODUZIR AND (V_DTAPRODUZIR+((P_QTPRODUZIR * E.QTHRUTIEQUIPROD)/E.VRCAPEQUIPPROD/24)))    OR
                                                  (V_DTAPRODUZIR BETWEEN C.DTHRINIUTEQUIP AND C.DTHRFINUTEQUIP)                                                            OR
                                                  ((V_DTAPRODUZIR+((P_QTPRODUZIR * E.QTHRUTIEQUIPROD)/E.VRCAPEQUIPPROD/24)) BETWEEN C.DTHRINIUTEQUIP AND C.DTHRFINUTEQUIP) 
                                              )
                                            ) 
                                        ORDER BY IDEQUIPPADRAO DESC,  NRORDUTILEQUIP)LOOP
                                        
                                        
                                        
                        IF C_EQUIPAMENTOS.QTHRSUTILEQUIP <= V_QTDEMINEQUIP THEN
                               --Se o equipamento alternativo demandar menos tempo, apenas recalcula o mesmo, almentando
                               --a diferena na data a produzir.
                               V_DTPRODTMP  := V_DTAPRODUZIR + (V_QTDEMINEQUIP-C_EQUIPAMENTOS.QTHRSUTILEQUIP); 
                               P_CDEQUIPPRO   := C_EQUIPAMENTOS.CDEQUIPPRO;
                               V_QTDEMINEQUIP := C_EQUIPAMENTOS.QTHRSUTILEQUIP;
                               V_EQUIPVALID := V_EQUIPVALID || '||' || C_EQUIPAMENTOS.CDEQUIPPRO;
                               -- Sai do Loop
                               EXIT; 
                        ELSE   
                               --revalidao utilizando o equipamento alternativo, tendo como data final a mesma data. Armazena em uma varivel intermediria
                               V_DTPRODTMP2 :=  ENCAIXA_PRODUCAO_TURNO(P_CDFILIAL,V_DTAPRODUZIR,P_CDPERIPRODU,C_EQUIPAMENTOS.QTHRSUTILEQUIP,P_MSGERROR,'S');
                               
                               
                               -------------------------------------------------------------------------------
                               --  Se a utilizao do equipamento alternativo permite uma produo mais rpida, 
                               --  troca para o mesmo. Caso contrrio, valida para o prximo equipamento alternativo 
                               --  (Deixa repetir o Loop).Se no for encontrado um equipamento alternativo com 
                               --  melhor resultado que V_DTPRODTMP (Adiantamento da produo usando o equipamento
                               --  padro, para evitar conflito), utiliza a mesma ento.
                               -------------------------------------------------------------------------------
                               IF V_DTPRODTMP2 > V_DTPRODTMP THEN
                                  V_DTAPRODUZIR  := V_DTPRODTMP2;
                                   --Troca V_DTPRODTMP por V_DTPRODTMP2, pois ao sair do Loop, V_DTAPRODUZIR ser trocada por V_DTPRODTMP
                                  V_DTPRODTMP    := V_DTPRODTMP2;
                                  V_QTDEMINEQUIP := C_EQUIPAMENTOS.QTHRSUTILEQUIP;
                                  P_CDEQUIPPRO   := C_EQUIPAMENTOS.CDEQUIPPRO;
                                  V_EQUIPVALID := V_EQUIPVALID || '||' || C_EQUIPAMENTOS.CDEQUIPPRO;
                                  -- Sai do Loop
                                  EXIT; 
                               END IF;                                           
                        END IF;
            END LOOP;
            --Se o cursor C_EQUIPAMENTOS NO tiver dados, V_DTPRODTMP = Produp realizada at 1 min. antes da alocao do equipamento para outro produto
            --Se o cursor C_EQUIPAMENTOS tiver dados, V_DTPRODTMP = Produo conforme calculada dentro do Loop, podendo ou no usar um equipamento alternativo
            V_DTAPRODUZIR := V_DTPRODTMP;    
        END IF;            
      END IF;   
   END LOOP;
   
   
   V_DTFINALPROD := V_DTAPRODUZIR + V_QTDEMINEQUIP;
   P_DTFINALPROD := V_DTFINALPROD;
   P_NRTURNO     := V_NRTURNO;
   
   --10. Retornar Data_Produzir
   RETURN( V_DTAPRODUZIR);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('VALIDA_DATA_PRODUCAO','5.05.016'); END;
/
